/*-------------------------------------------------------------------------------
Using Backtracking Algorithm....
Stores as the prefix encoding
Author: G.Kavitha
Input format: ./ProgName fileName NoOfVertices
Assuming fileName has: 
vertex vertex_code
edge_codes

fileName is the output file from store_prefix.cpp
---------------------------------------------------------------------------------*/

#include<bits/stdc++.h>
using namespace std;
# define l int
template <class T> struct compare : binary_function <T,T,bool> {
  bool operator() (const T& x, const T& y) const {if(x.length()==y.length()) return (x.compare(y)>0); return x.length()<y.length();}
};
class Graph{
	int V;
	map<string,l,compare<string> > vertex;//maps vertex_code to vertex
	map<l,string> vertex_codes;//maps vertex to vertex_code
	map<string,bool> edge_codes;//holds edge_codes
	map<l,int> color;
	int NoOfColors;
	bool isEdge(string a,string b); //to check whether there is any edge between a and b
	bool graphcolouring(int m,int colour[],int v);
	bool isOK(int v, int colour[],int c); //Helper function to check whether colour c is okay for vertex v with present colouring
 public:
 	Graph(l ver,char* s)
 	{
 		this->V=ver;
 		ifstream fin;
		fin.open(s,ios::in);
		l a; string b;
		int i=0;
		for(;i<V;i++)
		{
			fin>>a>>b;
			vertex_codes[a]=b;
			vertex[b]=a;
		}
		while(!fin.eof())
		{
			fin>>b;
			edge_codes[b]=true;
		}
		fin.close();
 	}
 	void coloring(int m);		
};
bool Graph::isEdge(string A,string B)
{
	if(A.compare(B)>0){A.swap(B);}
	int i=0;
	for(;i<A.length()&&i<B.length()&&A.at(i)==B.at(i);i++); //finds the position upto which the bits are identical
	A=A.substr(i);
	B=B.substr(i);
	reverse(A.begin(),A.end());
	A=A+B; //cout<<A<<"\n"; //A contains the constructed edge_code now
	if(edge_codes[A]==true) return true;
	return false;
}
bool Graph::isOK(int v, int colour[],int c)
{
	for(int i=0;i<V;i++)
	{
		if(isEdge(vertex_codes[v],vertex_codes[i])==true&&c==colour[i]) return false;
	}
	return true;
}
bool Graph::graphcolouring(int m,int colour[],int v)
{
	if(v==V) return true; //All vertices coloured so returns true
	for(int c=1;c<=m;c++)
	{
		if(isOK(v,colour,c))
		{
			//cout<<c<<"isOK "<<v<<"\n";
			colour[v]=c;
			if(graphcolouring(m,colour,v+1))
				return true;
			colour[v]=0; //Setting it to uncoloured again since graphcolouring(m,colour,v+1) returned false
		}
	}
	return false;//No colouring is possible
}
void Graph::coloring(int m)
{
	int *colour=new int[V];
	for(int i=0;i<V;i++)
		colour[i]=0;
	if(graphcolouring(m,colour,0)==false) cout<<"No solution with "<<m<<" colours\n";
	else {
		for(int i=0;i<V;i++)
		{color[i]=colour[i]; cout<<i<<" "<<color[i]<<"\n";}
	}
}
int main(int argc, char** argv)
{
	int m; cout<<"Enter no. of colours: ";cin>>m;
	clock_t t;
	t=clock();
	if(argc!=3) {cout<<"Usage : ./a.out filename V \n"; return 0;}
	l ver=atoi(argv[2]);
	Graph G(ver,argv[1]);
	G.coloring(m);
	t=clock()-t;
	cout<<"Time taken in seconds is: "<<(float(t))/CLOCKS_PER_SEC<<"\n";	
	return 0;
}