/*-------------------------------------------------------------------------------
Using Backtracking Algorithm....
Stored as Adjacency Matrix
Author: G.Kavitha
Input format: ./ProgName fileName NoOfVertices
Assuming vertices are numbered 0 to V-1
---------------------------------------------------------------------------------*/

#include<bits/stdc++.h>
using namespace std;
# define l int
class Graph{
	int V;
	map<l,int> color;
	bitset<25000000> adjmat; //Holds adjacency matrix
	void addEdge(l a,l b); //Function to add edge
	bool graphcolouring(int m,int colour[],int v);
	bool isOK(int v, int colour[],int c); //Helper function to check whether colour c is okay for vertex v with present colouring 
 public:
 	Graph(l ver,char* s)
 	{
 		this->V=ver;
 		ifstream fin;
		fin.open(s,ios::in);
		l a,b;
		while(!fin.eof())
		{
			fin>>a>>b;
			addEdge(a,b);
		}
		fin.close();
 	}
 	void coloring(int m);		
};
void Graph::addEdge(l a,l b)
{
	adjmat[V*a+b]=1;
	adjmat[V*b+a]=1;
}
bool Graph::isOK(int v, int colour[],int c)
{
	for(int i=0;i<V;i++)
	{
		if(adjmat.test(v*V+i)&&c==colour[i]) return false;
	}
	return true;
}
bool Graph::graphcolouring(int m,int colour[],int v)
{
	if(v==V) return true; //All vertices coloured so returns true
	for(int c=1;c<=m;c++)
	{
		if(isOK(v,colour,c))
		{
			//cout<<c<<"isOK "<<v<<"\n";
			colour[v]=c;
			if(graphcolouring(m,colour,v+1)) 
				return true;
			colour[v]=0; //Setting it to uncoloured again since graphcolouring(m,colour,v+1) returned false
		}
	}
	return false; //No colouring is possible
}
void Graph::coloring(int m)
{
	int *colour=new int[V];
	for(int i=0;i<V;i++)
		colour[i]=0; //Setting all to be uncoloured initially
	if(graphcolouring(m,colour,0)==false) cout<<"No solution with "<<m<<" colours\n";
	else {
		for(int i=0;i<V;i++)
		{color[i]=colour[i]; cout<<i<<" "<<color[i]<<"\n";}
	}
}
int main(int argc, char** argv)
{
	int m; cout<<"Enter no. of colours: ";cin>>m;
	clock_t t;
	t=clock();
	if(argc!=3) {cout<<"Usage : ./a.out filename V \n"; return 0;}
	l ver=atoi(argv[2]);
	Graph G(ver,argv[1]);
	G.coloring(m);
	t=clock()-t;
	cout<<"Time taken in seconds is: "<<(float(t))/CLOCKS_PER_SEC<<"\n";	
	return 0;
}
