/*-------------------------------------------------------------------------------
Reading in graph stored as prefix codes
Author: G.Kavitha
Input format: ./ProgName fileName NoOfVertices
Assuming fileName has: 
vertex vertex_code
edge_codes

i.e. it uses output of store_prefix.cpp as its input
DON'T NUMBER ANY VERTEX AS 0
---------------------------------------------------------------------------------*/

#include<bits/stdc++.h>
using namespace std;
# define l long long int
//------------------------------------------------
//Edited here
template <class T> struct compare : binary_function <T,T,bool> {
  bool operator() (const T& x, const T& y) const {if(x.length()==y.length()) return (x.compare(y)>0); return x.length()<y.length();}
};
//-------------------------------------------------
class Graph
{
	l V;
	//map<l,string> vertex_codes;
	map<string,l,compare <string> > vertex; //Edited here
	map<string,bool> edge_codes;
	map<l,int> color;
	int NoOfColors;
	bool isEdge(string a,string b);
	//bool bsearch(string a,int start,int end);
public:
	Graph(int ver, char* s)
	{
		this->V=ver;
		ifstream fin;
		fin.open(s,ios::in);
		l a;
		string b;
		int i=0;
		for(;i<V;i++)
		{
			fin>>a>>b;
			//vertex_codes[a]=b;
			vertex[b]=a;
		}
		while(!fin.eof())
		{
			fin>>b;
			edge_codes[b]=true;
		}
		fin.close();
	}
	void coloring();
};
/*bool Graph::bsearch(string a,int start,int end)
{
	cout<<start<<" "<<end<<"\n";
	if(start<=end)
	{
		int mid=(start)+(end-start)/2;
		cout<<"edge_codes[mid]"<<edge_codes[mid]<<"\n";
		if(a.compare(edge_codes[(mid)])==0) return true;
		if(a.compare(edge_codes[(mid)])>0) return bsearch(a,mid+1,end);
		if(a.compare(edge_codes[(mid)])<0) return bsearch(a,start,mid-1);
	}
	return false;
}*/
bool Graph::isEdge(string A,string B)
{
	if(A.compare(B)>0){A.swap(B);}
	int i=0;
	for(;i<A.length()&&i<B.length()&&A.at(i)==B.at(i);i++); //finds the position upto which the bits are identical
	A=A.substr(i);
	B=B.substr(i);
	reverse(A.begin(),A.end());
	A=A+B; //cout<<A<<"\n"; //A contains the constructed edge_code now
	//return(bsearch(A,0,edge_codes.size()-1));
	if(edge_codes[A]==true) return true;
	return false;
}
void Graph::coloring()
{
	NoOfColors=0;
	list<string> *VertOfColor=new list<string>[V]; //VertOfColor[i] contains vertices that are coloured with color i
	map<string,l>::iterator j;
	//for(map<string,bool>::iterator m=edge_codes.begin();m!=edge_codes.end();m++) cout<<(*m).first<<"\n";
	for(j=vertex.begin();j!=vertex.end();j++)
	{
		//cout<<"Colouring: "<<(*j).second<<"\n";
		bool colorfound=false;
		int i=0;
		//cout<<(*j).second<<"     "<<(*j).first<<"\n";
		while(i<NoOfColors)
		{
			list<string>::iterator k;
			for(k=VertOfColor[i].begin();k!=VertOfColor[i].end();k++) //searches if there is any vertex coloured i that has an edge with vertex (*j)
					if(isEdge((*k),(*j).first)) break;
			if(k==VertOfColor[i].end()) {colorfound=true; VertOfColor[i].push_back((*j).first); color[(*j).second]=i; break;}
			i++;
		}
		if(!colorfound) {VertOfColor[NoOfColors].push_back((*j).first); color[(*j).second]=NoOfColors; NoOfColors++;}
	}
	map<l,int>::iterator p;
	for(p=color.begin();p!=color.end();p++)
		cout<<(*p).first<<"-"<<(*p).second<<"\n";
	cout<<"NoOfColors: "<<NoOfColors<<"\n";
	
}
int main(int argc,char** argv)
{
	clock_t t;
	t=clock();
	if(argc!=3) {cout<<"Usage : ./a.out filename V \n"; return 0;}
	l ver=atoi(argv[2]);
	Graph G(ver,argv[1]);
	G.coloring();
	t=clock()-t;
	cout<<"Time taken in seconds is: "<<(float(t))/CLOCKS_PER_SEC<<"\n";	
	return 0;
}

