/*-------------------------------------------------------------------------------
Greedy Algorithm for Graph Colouring
Takes in Adjacency List
Author: G.Kavitha
Input format: ./ProgName fileName NoOfVertices
Assuming vertices are numbered 0 to V-1
---------------------------------------------------------------------------------*/

#include<bits/stdc++.h>
using namespace std;
# define l long long int
class Graph{
	l V;//No. of vertices
	list<l> *adj; //Adjacency List
	void addEdge(l a,l b);
	void colouring();
public:
	Graph(l ver,char* s)//Constructor
	{	
		this->V=ver;
		adj=new list<l> [V];
		ifstream fin;
		fin.open(s,ios::in);
		//string line;
	//	for(int i=0;i<4;i++)
	//	getline(fin,line);
		l a,b;
		while(!fin.eof())
		{
			fin>>a>>b;
			addEdge(a,b);//addEdge(a-1,b-1);
		}
		fin.close();
		colouring();
	}
	~Graph()//Destructor
	{
		delete [] adj;
	}
};
void Graph::addEdge(l a,l b)
{
	adj[a].push_back(b);
	adj[b].push_back(a);
}
void Graph::colouring()
{
	l *color=new l[V];//Holds the colour assigned to each vertex
	bool *neighbourcolor=new bool[V];//True when a neighbouring vertex is coloured with that colour
	color[0]=1;//Colouring Vertex 0 with Colour 1
	l max=1;//Maximum no.of colours used
	
	//Initially setting false for every colour
	for(l c=1;c<=V;c++)
		neighbourcolor[c]=false;
	for(l v=1;v<V;v++)
		color[v]=-1;//No colour initially assigned
	for(l v=1;v<V;v++)
	{
		list<l>::iterator i;
		for(i=adj[v].begin();i!=adj[v].end();i++)
		{
			if(color[*i]!=-1)
				neighbourcolor[color[*i]]=true;
		}
		l c;
		for(c=1;c<=V;c++) //Finding first unassigned colour
		{
			if(neighbourcolor[c]==false) break;
		}
		color[v]=c;
		for(i=adj[v].begin();i!=adj[v].end();i++)
		{
			if(color[*i]!=-1)
				neighbourcolor[color[*i]]=false; //Setting false for all colours again
		}
		if(c>max) max=c;
	}
	for(l v=0;v<V;v++)
	{
		cout<<v<<" - "<<color[v]<<"\n";
	}
	cout<<"No. of colours used: "<<max<<"\n";
}

int main(int argc, char *argv[])
{
	clock_t t;
	t=clock();
	if(argc!=3) {cout<<"Usage : ./a.out filename V\n";return 0;}
	l ver=atoll(argv[2]);
	Graph G(ver,argv[1]);
	t=clock()-t;
	cout<<"Time taken in seconds: "<<(float(t))/CLOCKS_PER_SEC<<"\n";	
	return 0;
}
