/*-------------------------------------------------------------------------------
Reading in graph and storing as prefix codes
Author: G.Kavitha
Input format: ./ProgName fileName NoOfVertices fileDestName
Assuming fileName has: 
vertex degree
edge vertex1 vertex2

DON'T NUMBER ANY VERTEX AS 0
---------------------------------------------------------------------------------*/

#include<bits/stdc++.h>
using namespace std;
# define SENTINAL '\0'
# define l long long int
struct node
{
	l character;
	l freq; 
	struct node *left;
	struct node *right;
	node(l chas, l fr){character= chas; freq=fr;left=NULL; right = NULL;};
 
};
 
typedef node node;
class nodeCompare {
	public:
    bool operator() (node *a, node *b) 
    {
    return (a->freq > b->freq);	
    }
};
class Graph
{
	l V;
	map<l,string> vertex_codes;
	vector<string> edge_codes;
	void print_heap(node *head, std::string path);
public:
	Graph(int ver,char* s1,char* s2)
	{
		this->V=ver;
		ifstream fin;
		fin.open(s1,ios::in);
		l a; l b;
		priority_queue<node *, vector<node *>, nodeCompare> minHeap;
		l i=0;
		for(;i<V;i++){
			fin>>a>>b; //Reading in vertex a and its degree b
			minHeap.push(new node(a,b));
		}

		//Generating vertex_codes for the vertices
		
		while(minHeap.size()>1)
		{
			//remove 1
			node *min1= minHeap.top();
			minHeap.pop();
			//remove 2
			node *min2= minHeap.top();
			minHeap.pop();
			//merge both
			node * new_node= new node(SENTINAL, min1->freq + min2->freq);
			new_node->left= min1;
			new_node->right= min2;
			//push back in minHeap
			minHeap.push(new_node);
		}
		print_heap(minHeap.top(), std::string(""));
		ofstream fout;
		fout.open(s2,ios::out);
		for(map<l,string>::iterator i=vertex_codes.begin();i!=vertex_codes.end();i++) fout<<"\n"<<(*i).first<<" "<<(*i).second;
		while(!fin.eof())
		{
			fin>>a;
			string A=vertex_codes[a];
			fin>>a;
			string B=vertex_codes[a];
			//Constructing edge codes
			if(A.compare(B)>0){A.swap(B);}
			l i=0;
			for(;i<A.length()&&i<B.length()&&A.at(i)==B.at(i);i++);
			A=A.substr(i);
			B=B.substr(i);
			reverse(A.begin(),A.end());
			fout<<"\n"<<A+B; 
			edge_codes.push_back(A+B);
		}
		fin.close();
		fout.close();
	}

};

void Graph::print_heap(node *head, std::string path)
{
	if(!head)
	return;
 	if(head->character !=SENTINAL)
	{
		//cout<<head->character<<"-"<<path<<"\n";
		vertex_codes[head->character]=path; //saving the vertex_code "path" for head->character
	}
 
	print_heap(head->left, "0"+path);
	print_heap(head->right, "1"+path);
}

int main(int argc,char** argv)
{
	clock_t t;
	t=clock();
	if(argc!=4) {cout<<"Usage : ./a.out filename V destFilename\n"; return 0;}
	l ver=atoll(argv[2]);
	Graph G(ver,argv[1],argv[3]);
	t=clock()-t;
	cout<<"Time taken in seconds is: "<<(float(t))/CLOCKS_PER_SEC<<"\n";	
	return 0;
}
